require({cache:{
'url:citrix/xenclient/templates/ConnectDevice.html':"<div class=\"citrixDialog alertDialog\" dojoAttachPoint=\"containerNode\" tabindex=\"-1\" waiRole=\"dialog\" waiState=\"labelledby-${id}_title\">\n\t<div class=\"citrixDialogTitleBar\">\n        <span dojoAttachPoint=\"titleNode\" class=\"citrixDialogTitle\" id=\"${id}_title\"></span>\n        <span dojoAttachPoint=\"closeButtonNode\" class=\"citrixDialogCloseIcon\" dojoAttachEvent=\"onclick: onCancel\">\n            <span dojoAttachPoint=\"closeText\"></span>\n        </span>\n\t</div>\n    <div class=\"citrixDialogPaneContent\">\n        <ul class=\"connectDevice\" dojoType=\"citrix.common.Repeater\" dojoEventHandler=\"this\" name=\"getAvailableDevices\" uniqueId=\"dev_id\">\n            <li template deviceId=\"%dev_id%\">\n                <div class=\"device\" templateType=\"citrix.common.BoundWidget\" binding=\"disabled\" bind=\"cannotAssign\" dojoAttachEvent=\"onClick: onDeviceSelect\">\n                    <span class=\"alertIcon alertIconSmall alertIconWarning deviceIcon\" templateType=\"citrix.common.BoundWidget\" binding=\"display\" bind=\"assignedToOtherVM\"></span>\n                    <div class=\"deviceName deviceUSB\" templateType=\"citrix.common.BoundWidget\" bind=\"name\"></div>\n                    <div class=\"deviceStatus deviceUSB\" templateType=\"citrix.common.BoundWidget\" bind=\"getStatus\" mask=\"value\" map=\"['${USB_STATE_0}', '${USB_STATE_1}', '${USB_STATE_2}', '${USB_STATE_3}', '${USB_STATE_4}', '${USB_STATE_5}', '${USB_STATE_6}', '${USB_STATE_7}', '${USB_STATE_8}', '${USB_STATE_9}', '${USB_STATE_10}', '${USB_STATE_11}']\"></div>\n                </div>\n            </li>\n            <li empty class=\"noDevices\">${USB_NONE_AVAILABLE}</li>\n        </ul>\n        <div dojoAttachPoint=\"alwaysUseContainer\">\n            <input id=\"alwaysUse\" type=\"checkbox\" dojoType=\"citrix.common.CheckBox\" dojoAttachPoint=\"alwaysUseNode\"/>\n            <label for=\"alwaysUse\">${USB_ALWAYS_USE}</label>\n        </div>\n    </div>\n    <div dojoAttachPoint=\"footerNode\" class=\"citrixDialogFooterContent\">\n        <span class=\"citrixDialogFooter right\">\n            <button dojoAttachPoint=\"connectButton\" dojoType=\"citrix.common.Button\" class=\"citrixDialogItemRight\" dojoAttachEvent=\"onClick: onExecute\">${CONNECT_USB_ACTION}</button>\n            <button dojoType=\"citrix.common.Button\" class=\"citrixDialogItemRight\" dojoAttachEvent=\"onClick: onCancel\">${CANCEL_USB_ACTION}</button>\n        </span>\n    </div>\n</div>\n"}});
define("citrix/xenclient/ConnectDevice", [
    "dojo",
    "dojo/_base/declare",
    "dojo/_base/array",
    // Resources
    "dojo/i18n!citrix/xenclient/nls/ConnectDevice",
    "dojo/text!citrix/xenclient/templates/ConnectDevice.html",
    // Mixins
    "citrix/common/Dialog",
    "citrix/common/_BoundContainerMixin",
    // Required in code
    "dojo/NodeList-traverse",
    // Required in template
    "citrix/common/Repeater",
    "citrix/common/BoundWidget",
    "citrix/common/CheckBox",
    "citrix/common/Button"
],
function(dojo, declare, array, connectDeviceNls, template, dialog, _boundContainerMixin) {
return declare("citrix.xenclient.ConnectDevice", [dialog, _boundContainerMixin], {

    templateString: template,
    widgetsInTemplate: true,
    canExecute: true,
    destroyOnHide: true,
    _deviceId: -1,

    constructor: function(args) {
        this.vm = XUICache.getVM(args.path);
        // Refresh when opening dialog
        this.vm.refreshUsb();
        // keep the host and the local in sync in case new devices have been inserted
        XUICache.Host.refreshUsb();
    },

    postMixInProperties: function() {
        dojo.mixin(this, connectDeviceNls);
        this.inherited(arguments);
    },

    postCreate: function() {
        this.inherited(arguments);
        this.subscribe(this.vm.publish_topic, this._messageHandler);
        this._bindDijit();
    },

    onDeviceSelect: function(event) {
        if (dojo.hasClass(event.currentTarget, "disabled")) {
            return;
        }
        var id = this._getDeviceID(event.currentTarget);
        if (id == this._deviceId) {
            return;
        }
        this._deviceId = id;
        this._setClass(".device", "selected", false);
        this._setClass(event.currentTarget, "selected", true);
        this._setVisible(this.alwaysUseContainer, true);
        this.alwaysUseNode.set("value", false);
        this._setEnabled(this.connectButton, true);
    },

    onExecute: function() {
        var vm = this.vm;
        var usb = this.vm.usbDevices[this._deviceId];
        // mock data to work with the host model function
        usb.assigned_uuid = vm.uuid;
        usb.getSticky = [this.alwaysUseNode.checked];

        var onError = function(error) {
            XUICache.messageBox.showError(error, XenConstants.ToolstackCodes);
        };

        var complete = function() {
            XUICache.USB.set_usbDevice(usb, dojo.hitch(this, function(){
                this.vm.refresh();
            }));
        };
        if (usb.assignedToOtherVM()) {
            // Confirm stealing device from another VM
            var message = (usb.state == 2) ? this.USB_FORCE_REASSIGN : this.USB_REASSIGN;
            XUICache.messageBox.showConfirmation(message, dojo.hitch(this, complete));
        } else {
            complete.call(this);
        }

        this.inherited(arguments);
    },

    _bindDijit: function() {
        this.bind(this.vm);
        this.set("title", this.CONNECT_DEVICE);
        this._setVisible(this.alwaysUseContainer, false);
        this._setEnabled(this.connectButton, false);
    },

    _getDeviceID: function(node) {
        return new dojo.NodeList(node).parents("li").first()[0].getAttribute("deviceId");
    },

    _messageHandler: function(message) {
        switch(message.type) {
            case XenConstants.TopicTypes.MODEL_USB_CHANGED:
                if(!XUICache.USB.isUsbBusy()){
                    this._bindDijit();
                }
                break;
            case XenConstants.TopicTypes.MODEL_STATE_CHANGED:
            case XenConstants.TopicTypes.MODEL_CHANGED: {
                this._bindDijit();
                break;
            }
        }
    }
});
});
