require({cache:{
'url:citrix/xenclient/templates/StartupWizard.html':"<div class=\"citrixDialog\" tabindex=\"-1\" waiRole=\"dialog\" waiState=\"labelledby-${id}_title\">\n  \t<div class=\"citrixDialogTitleBar\">\n        <span dojoAttachPoint=\"titleNode\" class=\"citrixDialogTitle\" id=\"${id}_title\">${DEFERRED_INSTALL_TITLE}</span>\n        <span dojoAttachPoint=\"closeButtonNode\" class=\"citrixDialogCloseIcon\" dojoAttachEvent=\"onclick: onCancel\">\n            <span dojoAttachPoint=\"closeText\"></span>\n        </span>\n    </div>\n    <div class=\"citrixDialogPaneContent\">\n        <div id=\"${wizardId}\" dojoType=\"citrix.common.WizardContainer\" dojoAttachPoint=\"wizard\">\n            <div dojoType=\"citrix.common.WizardPage\" title=\"${LANGUAGE_HEADER}\" isReturnable=\"false\" selected=\"true\" dojoAttachPoint=\"languagePage\">\n                <fieldset class=\"citrixTabPaneColumn single\">\n                    <p>${LANGUAGE_INSTR}</p>\n                    <div class=\"citrixTabPaneField\">\n                        <select class=\"citrix\" dojoType=\"citrix.common.Select\" dojoAttachPoint=\"languageSelect\" name=\"language\"></select>\n                    </div>\n                </fieldset>\n            </div>\n            <div class=\"eulaPage\" dojoType=\"citrix.common.WizardPage\" title=\"${EULA_HEADER}\" isReturnable=\"false\" dojoAttachPoint=\"eulaPage\">\n                <fieldset class=\"citrixTabPaneColumn single\">\n                    <div class=\"eula\" dojoAttachPoint=\"eulaContent\"></div>\n                </fieldset>\n                <div class=\"alignBottom\">\n                    <div class=\"alertBox orangeBox\">\n                        <span class=\"alertIcon alertIconSmall alertIconWarning\"></span>\n                        <div>${EULA_ERROR}</div>\n                    </div>\n                </div>\n            </div>\n            <div dojoType=\"citrix.common.WizardPage\" title=\"${KEYBOARD_HEADER}\" isReturnable=\"false\" dojoAttachPoint=\"keyboardPage\">\n                <fieldset class=\"citrixTabPaneColumn single\">\n                    <p>${KEYBOARD_INSTR}</p>\n                    <div dojoType=\"citrix.common.Repeater\" dojoAttachPoint=\"kbRepeater\" dojoEventHandler=\"this\">\n                        <div class=\"citrixTabPaneField radio\" template>\n                            <input type=\"radio\" templateType=\"citrix.common.RadioButton\" bind=\"keyboard\" id=\"kb_%id%\" value=\"%id%\" />\n                            <label for=\"kb_%id%\">%label%</label>\n                        </div>\n                    </div>\n                </fieldset>\n            </div>\n            <div dojoType=\"citrix.common.WizardPage\" title=\"${ROOT_PASSWORD_HEADER}\" isReturnable=\"false\" dojoAttachPoint=\"passwordPage\">\n                <fieldset class=\"citrixTabPaneColumn single\">\n                </fieldset>\n            </div>\n        </div>\n    </div>\n    <div dojoAttachPoint=\"footerNode\" class=\"citrixDialogFooterContent\">\n        <span class=\"citrixDialogFooter right\" wizardId=\"${wizardId}\" dojoType=\"citrix.common.WizardNavigator\" dojoAttachPoint=\"navigationNode\"></span>\n    </div>\n</div>\n"}});
define("citrix/xenclient/StartupWizard", [
    "dojo",
    "dojo/_base/declare",
    // Resources
    "dojo/i18n!citrix/xenclient/nls/Alerts",
    "dojo/i18n!citrix/xenclient/nls/StartupWizard",
    "dojo/text!citrix/xenclient/templates/StartupWizard.html",
    // Mixins
    "citrix/xenclient/_Wizard",
    // Required in template
    "citrix/common/WizardContainer",
    "citrix/common/WizardPage",
    "citrix/common/Select",
    "citrix/common/Repeater",
    "citrix/common/RadioButton",
    "citrix/common/WizardNavigator"
],
function(dojo, declare, alertsNls, startupWizardNls, template, _wizard) {
return declare("citrix.xenclient.StartupWizard", [_wizard], {

    templateString: template,

    wizardId: "StartupWizard",
    canCancel: false,

    postMixInProperties: function() {
        dojo.mixin(this, startupWizardNls);

        this.inherited(arguments);
    },

    postCreate: function() {
        this.inherited(arguments);

        this.languagePage.onNextFunction = dojo.hitch(this, this._onLanguagePageNext);
        this.eulaPage.onStartFunction = dojo.hitch(this, this._onEulaPageStart);
        this.eulaPage.onNextFunction = dojo.hitch(this, this._onEulaPageNext);
        this.keyboardPage.onNextFunction = dojo.hitch(this, this._onKeyboardPageNext);
        this.passwordPage.onStartFunction = dojo.hitch(this, this._onPasswordPageStart);
    },

    _toolstackError: function(error) {
        XUICache.messageBox.showError(error, XenConstants.ToolstackCodes);
    },

    startup: function() {
        this.inherited(arguments);

        // only display this for EULA
        this._setDisplay(this.navigationNode.cancelButton, false);

        if(!XUICache.Host.deferred_language.bool()) {
            this.wizard.closeChild(this.languagePage);
        } else {
            if(XUICache.Host.supported_languages.length <= 1) {
                XUICache.Host.setInstallState("language-set", dojo.hitch(this, function() {
                    this.wizard.closeChild(this.languagePage);
                }), this._toolstackError);
            } else {
                var languageMap = dojo.map(XUICache.Host.supported_languages, function(language) {
                    var opt = {};
                    opt["value"] = language;
                    opt["label"] = this["LANGUAGE_" + language.substring(3).toUpperCase()];
                    return opt;
                }, this);

                this.languageSelect.set("options", languageMap);
                this.languageSelect.set("value", XUICache.Host.language == "" ? languageMap[0].value : XUICache.Host.language);
            }
        }
        if(!XUICache.Host.deferred_eula.bool()) {
            this.wizard.closeChild(this.eulaPage);
            this._setButtonsForEula(false);
        } else {
            XUICache.Host.getEULA(
                dojo.hitch(this, function(result) {
                    this.eulaContent.innerHTML = result;
                }),
                this._toolstackError
            );
        }
        if (!XUICache.Host.deferred_keyboard.bool()) {
            this.wizard.closeChild(this.keyboardPage);
        } else {
            this.kbRepeater.set(
                "value",
                dojo.map(XUICache.Host.keyboard_layouts, dojo.hitch(this, function(item) {
                    return {"id": item, "label": this["KEYBOARD_LAYOUT_" + item.toUpperCase().replace(/-/g, "_")]};
                }))
            );
            var children = this.kbRepeater.getChildren();
            if(children && children.length > 0) {
                children[0].set("checked", true);
                if(this.keyboardPage.selected) {
                    children[0].focus();
                }
            }
        }
        if (!XUICache.Host.deferred_password.bool()) {
            this.wizard.closeChild(this.passwordPage);
        }
    },

    onCancel: function() {
        this.inherited(arguments);

        // Can only cancel on EULA page, and if you do this is the result.
        XUICache.Host.shutdown();
    },

    onExecute: function() {
        this.inherited(arguments);

        // refresh the Host so that the deferred properties are cleared
        XUICache.Host.refresh();
    },

    _setButtonsForEula: function(/*boolean*/ value) {
        this.navigationNode.set("nextLabel", value ? this.ACCEPT_ACTION : this.NEXT_ACTION);
        this.navigationNode.set("finishLabel", value ? this.ACCEPT_ACTION : this.FINISH_ACTION);
        this._setDisplay(this.navigationNode.cancelButton, value);
    },

    _onEulaPageStart: function() {
        this._setButtonsForEula(true);
    },

    _onEulaPageNext: function(finish) {
        XUICache.Host.setInstallState(
            "eula-accepted",
            dojo.hitch(this, function() {
                this._setButtonsForEula(false);
                finish();
            }),
            this._toolstackError
        );
    },

    _onKeyboardPageNext: function(finish) {
        var result = this.unbind();
        XUICache.Host.save(
            "keyboard_layout",
            result.keyboard,
            dojo.hitch(this, function() {
                XUICache.Host.setInstallState(
                    "kb-layout-set",
                    finish,
                    this._toolstackError
                );
            }),
            this._toolstackError
        );
    },

    _onLanguagePageNext: function(finish) {
        var result = this.unbind();
        XUICache.Host.setInstallState("language-set", dojo.hitch(this, function() {
            if(XUICache.Host.language != result.language) {
                XUICache.Host.save("language", result.language, finish, this._toolstackError);
            } else {
                finish();
            }
        }), this._toolstackError);
    },

    _onPasswordPageStart: function() {
        var flags = XenConstants.AuthFlags.SET_ROOT_PW | XenConstants.AuthFlags.CONFIRM_PW | XenConstants.AuthFlags.CANNOT_CANCEL;
        XUICache.Host.authSetContextFlags("", "", flags,
            dojo.hitch(this, function() {
                XUtils.publish(XenConstants.TopicTypes.UI_SHOW_POPUP, [this.SET_SYSTEM_PASSWORD + "<br/>" + alertsNls.AUTH_START, alertsNls.AUTH_START_HEADING]);
                // login returns straight away
                this.subscribe("com.citrix.xenclient.input", dojo.hitch(this, function(obj) {
                    switch(obj.type) {
                        case "auth_status":
                            this.onExecute();
                            break;
                    }
                }));
            }),
            this._toolstackError
        );
    }
});
});
